include masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
DragContainer proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
BindContainer proto hDest:HWND,HandHoldsSize:DWORD,hInst:HINSTANCE

HANDHOLDS_SIZE EQU 6

IDT_SC EQU 0BADh
CSCI struct
	a				DWORD	? ; size of handholds (square)
	pPage			PVOID	? ; ptr SubCalssTrampoline -> VirtualFree()
	bDrag			DWORD	?
	index			DWORD	? ; handhold-index
	mode			DWORD	? ; 0 = drag , 1 = size
	ptDown			POINT	<>
CSCI ends

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,0
	mov wcex.hbrBackground,rv(GetStockObject,GRAY_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"Resize Controls",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

align 16
WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_CREATE

		;/* create the controls an subcalss them */
		
		fn CreateWindowEx,0,"Button","Click Me",WS_CHILD or WS_VISIBLE or WS_DLGFRAME,10,10,100,100,hWnd,0,hInstance,0
		invoke BindContainer,eax,HANDHOLDS_SIZE,hInstance

		fn CreateWindowEx,0,"Edit","xyz",WS_CHILD or WS_VISIBLE,120,10,100,100,hWnd,0,hInstance,0
		invoke BindContainer,eax,HANDHOLDS_SIZE,hInstance

		fn CreateWindowEx,0,"SysMonthCal32","xyz",WS_CHILD or WS_VISIBLE,50,130,200,200,hWnd,0,hInstance,0
		invoke BindContainer,eax,HANDHOLDS_SIZE,hInstance

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

align 16
SubCalssTrampoline:
	mov edx,02BADF00Dh	; edx = pOrgWndProc
	mov ecx,02BADF00Dh  ; ecx = ptr CSCI
	mov eax,02BADF00Dh	; eax = pWndProcSubCalss
	jmp eax
SubCalssTrampoline_end:

align 16
GetHandHoldsRect proc uses edi esi hWnd:HWND,a:DWORD,pRect: ptr RECT
LOCAL rect[8]:RECT

; handholds:
;            0---7---6
;            |       |
;            1       5
;            |       |
;            2---3---4
;
	invoke RtlZeroMemory,ADDR rect[16],(SIZEOF RECT)*7
	invoke GetWindowRect,hWnd,ADDR rect
	mov esi,rect.right
	mov edi,rect.bottom
	sub esi,rect.left  ; w
	sub edi,rect.top   ; h
	mov edx,a          ; a
	mov ecx,edx
	shr ecx,1          ; 0.5*a

	mov rect.left,0
	mov rect.top,0
	
	; y: 0 & 7 & 6
	mov rect[0*16].bottom,edx
	mov rect[6*16].bottom,edx
	mov rect[7*16].bottom,edx
	
	; y: 1 & 5
	mov eax,edi
	shr eax,1
	sub eax,ecx
	mov rect[1*16].top,eax
	mov rect[5*16].top,eax
	lea eax,[eax+edx]
	mov rect[1*16].bottom,eax
	mov rect[5*16].bottom,eax

    ; y: 2 & 3 & 4
	mov eax,edi
	sub eax,edx
	mov rect[2*16].top,eax
	mov rect[3*16].top,eax
	mov rect[4*16].top,eax
	mov rect[2*16].bottom,edi
	mov rect[3*16].bottom,edi
	mov rect[4*16].bottom,edi
	
	; x: 0 & 1 & 2
	mov rect[0*16].right,edx
	mov rect[1*16].right,edx
	mov rect[2*16].right,edx
	
	; x: 3 & 7
	mov eax,esi
	shr eax,1
	sub eax,ecx
	mov rect[3*16].left,eax
	mov rect[7*16].left,eax
	lea eax,[eax+edx]
	mov rect[3*16].right,eax
	mov rect[7*16].right,eax
	
	; x: 4 & 5 & 6
	mov eax,esi
	sub eax,edx
	mov rect[4*16].left,eax
	mov rect[5*16].left,eax
	mov rect[6*16].left,eax
	mov rect[4*16].right,esi
	mov rect[5*16].right,esi
	mov rect[6*16].right,esi
	
	invoke RtlMoveMemory,pRect,ADDR rect,(SIZEOF RECT)*8
	mov eax,1
	ret
	
GetHandHoldsRect endp

align 16
DrawHandHolds proc uses ebx esi edi hWnd:HWND,a:DWORD
LOCAL hdc:HDC
LOCAL rect[8]:RECT

	invoke GetHandHoldsRect,hWnd,a,ADDR rect
	
	mov hdc,rv(GetWindowDC,hWnd)

	mov ebx,rv(GetStockObject,BLACK_BRUSH)
	mov edi,LENGTHOF rect
	lea esi,rect
	.while edi
		invoke BitBlt,hdc,[esi].RECT.left,[esi].RECT.top,a,a,hdc,0,0,PATCOPY
		invoke FrameRect,hdc,esi,ebx
		lea esi,[esi+SIZEOF RECT]
		lea edi,[edi-1]
	.endw

	invoke ReleaseDC,hWnd,hdc

	ret
	
DrawHandHolds endp

; uses screen coord.
; return: index of handhold {0...7} or -1 if no hit
align 16
HandHoldsHitTest proc uses edi esi ebx hWnd:DWORD,a:DWORD,x:DWORD,y:DWORD
LOCAL rect[9]:RECT	
	
	invoke GetHandHoldsRect,hWnd,a,ADDR rect
	
	invoke GetWindowRect,hWnd,ADDR rect[8*16]
	lea esi,rect
	xor edi,edi
	mov ecx,rect[8*16].left
	mov edx,rect[8*16].top
	.while edi < 8
		add [esi].RECT.left,ecx
		add [esi].RECT.top,edx
		add [esi].RECT.right,ecx
		add [esi].RECT.bottom,edx
		push ecx
		push edx
		invoke PtInRect,esi,x,y
		.if eax
			add esp,8
			mov eax,edi
			ret
		.endif
		pop edx
		pop ecx
		lea esi,[esi+SIZEOF RECT]
		lea edi,[edi+1]
	.endw
	mov eax,-1	
	ret
	
HandHoldsHitTest endp

align 16
ResizeCntrl proc uses ebx esi edi hWnd:HWND,index:DWORD,a:DWORD,_dx:DWORD,dy:DWORD
LOCAL rect:RECT

	invoke GetWindowRect,hWnd,ADDR rect
	mov ebx,rv(GetParent,hWnd)
	invoke ScreenToClient,ebx,ADDR rect.left
	invoke ScreenToClient,ebx,ADDR rect.right
	mov esi,_dx
	mov edi,dy
	
	.if index == 0
		add rect.left,esi
		add rect.top,edi
	.elseif index == 1
		add rect.left,esi
	.elseif index == 2
		add rect.left,esi
		add rect.bottom,edi
	.elseif index == 3
		add rect.bottom,edi
	.elseif index == 4
		add rect.right,esi
		add rect.bottom,edi
	.elseif index == 5
		add rect.right,esi
	.elseif index == 6
		add rect.right,esi
		add rect.top,edi
	.elseif index == 7
		add rect.top,edi
	.endif
	mov esi,rect.right
	mov edi,rect.bottom
	sub esi,rect.left
	sub edi,rect.top
	
	mov ecx,a
	lea eax,[ecx*2+ecx]
	.if SDWORD ptr esi < eax
		.if index == 0 ||index == 1 || index == 2
			m2m rect.left,rect.right
			sub rect.left,eax
		.elseif index == 4 || index == 5 || index == 6
			m2m rect.right,rect.left
			add rect.right,eax
		.endif
	.endif
	.if SDWORD ptr edi < eax
		.if index == 0 ||index == 7 || index == 6
			m2m rect.top,rect.bottom
			sub rect.top,eax
		.elseif index == 2 || index == 3 || index == 4
			m2m rect.bottom,rect.top
			add rect.bottom,eax
		.endif
	.endif

	mov esi,rect.right
	mov edi,rect.bottom
	sub esi,rect.left
	sub edi,rect.top
	
	invoke MoveWindow,hWnd,rect.left,rect.top,esi,edi,1
	ret
	
ResizeCntrl endp

;/* This is the subcalss procedure, which is called through the trampoline-function */
;/*  on entry: edx = pOrgWndProc , ecx = ptr CSCI                                   */
align 16
ContainerSubCalss proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL pWndProc:WNDPROC
LOCAL hDragContainer:HWND
LOCAL rect:RECT
LOCAL pt:POINT
LOCAL hdc:HDC

	mov pWndProc,edx
	mov ebx,ecx
	.if uMsg == WM_DESTROY
		invoke SetWindowLong,hWnd,GWL_WNDPROC,pWndProc
		mov esi,OFFSET SubCalssTrampoline_end - OFFSET SubCalssTrampoline
		invoke VirtualFree,[ebx].CSCI.pPage,esi,MEM_DECOMMIT
		free ebx
	.elseif uMsg == WM_NCHITTEST
		invoke GetCursorPos,ADDR pt
		.if rv(HandHoldsHitTest,hWnd,[ebx].CSCI.a,pt.x,pt.y) != -1
			mov eax,HTBORDER
			ret
		.endif
	.elseif uMsg == WM_LBUTTONDOWN || uMsg == WM_NCLBUTTONDOWN
		invoke GetCursorPos,ADDR pt
		.if rv(HandHoldsHitTest,hWnd,[ebx].CSCI.a,pt.x,pt.y) != -1 && ![ebx].CSCI.bDrag
			mov [ebx].CSCI.index,eax
			invoke SetCapture,hWnd
			invoke SetWindowPos,hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE
			mov [ebx].CSCI.bDrag,1
			m2m [ebx].CSCI.ptDown.x,pt.x
			m2m [ebx].CSCI.ptDown.y,pt.y
			.if rv(GetAsyncKeyState,VK_CONTROL) & 8000h
				m2m [ebx].CSCI.mode,0
			.else
				m2m [ebx].CSCI.mode,1
			.endif
		.else
			jmp @draw
		.endif
	.elseif [ebx].CSCI.bDrag
		.if uMsg == WM_MOUSEMOVE || uMsg == WM_NCMOUSEMOVE
			invoke GetCursorPos,ADDR pt
			mov ecx,[ebx].CSCI.ptDown.x
			mov edx,[ebx].CSCI.ptDown.y
			sub pt.x,ecx
			sub pt.y,edx
			.if pt.x || pt.y
				invoke GetCursorPos,ADDR [ebx].CSCI.ptDown
				.if ![ebx].CSCI.mode
					invoke GetWindowRect,hWnd,ADDR rect
					mov ebx,rv(GetParent,hWnd)
					invoke ScreenToClient,ebx,ADDR rect.left
					invoke ScreenToClient,ebx,ADDR rect.right
					mov ecx,pt.x
					mov edx,pt.y
					add rect.left,ecx
					add rect.top,edx
					add rect.right,ecx
					add rect.bottom,edx
					mov ecx,rect.right
					mov edx,rect.bottom
					sub ecx,rect.left
					sub edx,rect.top
					invoke MoveWindow,hWnd,rect.left,rect.top,ecx,edx,1
				.else
					invoke ResizeCntrl,hWnd,[ebx].CSCI.index,[ebx].CSCI.a,pt.x,pt.y
				.endif
			.endif
		.elseif uMsg == WM_LBUTTONUP || uMsg == WM_NCLBUTTONUP
			invoke ReleaseCapture
			mov [ebx].CSCI.bDrag,0
		.else
			jmp @draw
		.endif
		xor eax,eax
		ret
	.elseif uMsg == WM_PAINT || uMsg == WM_MOUSEMOVE || uMsg == WM_RBUTTONDOWN || uMsg == WM_RBUTTONUP || uMsg == WM_RBUTTONDBLCLK || uMsg == WM_LBUTTONDBLCLK || uMsg == WM_LBUTTONDOWN || uMsg == WM_LBUTTONUP || uMsg == WM_CHAR
		jmp @draw
	.elseif uMsg == WM_NCMOUSEMOVE || uMsg == WM_NCRBUTTONDOWN || uMsg == WM_NCRBUTTONUP || uMsg == WM_NCRBUTTONDBLCLK || uMsg == WM_NCLBUTTONDBLCLK || uMsg == WM_NCLBUTTONDOWN || uMsg == WM_NCLBUTTONUP
@draw:	invoke CallWindowProc,pWndProc,hWnd,uMsg,wParam,lParam
		push eax
		invoke DrawHandHolds,hWnd,[ebx].CSCI.a
		pop eax
		ret
	.elseif uMsg == WM_TIMER && wParam == IDT_SC
		invoke DrawHandHolds,hWnd,[ebx].CSCI.a
		ret
	.endif	
	invoke CallWindowProc,pWndProc,hWnd,uMsg,wParam,lParam
	ret
	
ContainerSubCalss endp

align 16
BindContainer proc uses edi esi ebx hDest:HWND,HandHoldsSize:DWORD,hInst:HINSTANCE
LOCAL pWndProc:WNDPROC
	
	mov ebx,alloc(SIZEOF CSCI)
	
	invoke GetWindowLong,hDest,GWL_STYLE
	or eax,WS_CLIPSIBLINGS
	invoke SetWindowLong,hDest,GWL_STYLE,eax
	mov pWndProc,rv(GetWindowLong,hDest,GWL_WNDPROC)
	
	; create subclass-trampoline
	mov esi,OFFSET SubCalssTrampoline_end - OFFSET SubCalssTrampoline
	mov edi,rv(VirtualAlloc,0,esi,MEM_COMMIT,PAGE_EXECUTE_READWRITE)
	m2m [ebx].CSCI.pPage,edi
	m2m [ebx].CSCI.a,HandHoldsSize
	
	; copy code-template
	xor ecx,ecx
	.while ecx < esi
		mov al,BYTE ptr SubCalssTrampoline[ecx]
		mov BYTE ptr [edi+ecx],al
		lea ecx,[ecx+1]
	.endw
	
	; fill code-template
	m2m WNDPROC ptr [edi+1],pWndProc
	mov HWND ptr [edi+5+1],ebx
	mov HWND ptr [edi+2*5+1],OFFSET ContainerSubCalss
		
	invoke SetWindowLong,hDest,GWL_WNDPROC,edi
	
	invoke SetTimer,hDest,IDT_SC,30,0
	
	mov eax,1
	ret
	
BindContainer endp

end main
